# delivery_engine_client

This is the delivery_engine API.
It is a FastAPI application that provides a RESTful API.


This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.0
- Package version: 1.0.0
- Generator version: 7.5.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import delivery_engine_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import delivery_engine_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import delivery_engine_client
from delivery_engine_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = delivery_engine_client.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
async with delivery_engine_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = delivery_engine_client.DeliveriesApi(api_client)
    subscriber_id = 56 # int | 
    message = delivery_engine_client.Message() # Message | 

    try:
        # Deliver Message
        api_response = await api_instance.deliver_message_deliveries_deliver_message_post(subscriber_id, message)
        print("The response of DeliveriesApi->deliver_message_deliveries_deliver_message_post:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DeliveriesApi->deliver_message_deliveries_deliver_message_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DeliveriesApi* | [**deliver_message_deliveries_deliver_message_post**](docs/DeliveriesApi.md#deliver_message_deliveries_deliver_message_post) | **POST** /deliveries/deliver_message | Deliver Message
*DeliveriesApi* | [**process_queue_deliveries_process_queue_post**](docs/DeliveriesApi.md#process_queue_deliveries_process_queue_post) | **POST** /deliveries/process_queue | Process Queue
*HealthApi* | [**health_check_health_get**](docs/HealthApi.md#health_check_health_get) | **GET** /health/ | Health Check


## Documentation For Models

 - [DeliverMessageResponse](docs/DeliverMessageResponse.md)
 - [HTTPValidationError](docs/HTTPValidationError.md)
 - [Message](docs/Message.md)
 - [ValidationError](docs/ValidationError.md)
 - [ValidationErrorLocInner](docs/ValidationErrorLocInner.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author

jose@ambientlabscomputing.com


